Unit SF56R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF14_p, SF51R_p;

function SF56R(P :Real; DF :Real; var IERR :Integer): Real;

implementation

function SF56R(P :Real; DF :Real; var IERR :Integer): Real;
var
IERR1 :Integer;
F,Q,X,A,B,C,D,XX,Y :Real;
const
SYS005 :Real = 1.5707963267948966192313216916397;
SYS059 :Real = 3.4E38;
SYS089 :Real = 1.0E-6;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
{ Result -    SF56R  FORTRANe }
IERR := 0;
F := DF;
Q := P;
if ( F >= 1.0 ) 
 then goto _1;
IERR := 65;
goto _7;
_1:
if ( (Q <= 0.0) ) or ( (Q >= 1.0) ) 
 then goto _6;
if ( Abs(F-2.0) > SYS089 ) 
 then goto _2;
X := Sqrt(2.0/(Q*(2.0-Q))-2.0);
goto _8;
_2:
if ( Abs(F-1.0) > SYS089 ) 
 then goto _3;
A := Q*SYS005;
X := Cos(A)/Sin(A);
goto _8;
_3:
A := 1.0/(F-0.5);
B := 48.0/(A*A);
C := ((20700.0*A/B-98.0)*A-16.0)*A+96.36;
D := ((94.5/(B+C)-3.0)/B+1.0)*Sqrt(A*SYS005)*F;
XX := D*Q;
Y := Power(XX,2.0/F);
if ( Y > A+0.05 ) 
 then goto _5;
Y := ((1.0/(((F+6.0)/(F*Y)-0.089*D-0.822)*(F+2.0)*3.0)+
    0.5/(F+4.0))*Y-1.0)*(F+1.0)/(F+2.0)+1.0/Y;
_4:
X := Sqrt(F*Y);
goto _8;
_5:
X := 0.5*Q;
XX := SF51R(X,IERR1);
Y := XX*XX;
if ( F < 5.0 ) 
 then C := C+0.3*(F-4.5)*(XX+0.6);
C := (((0.05*D*XX-5.0)*XX-7.0)*XX-2.0)*XX+B+C;
Y := (((((0.4*Y+6.3)*Y+36.0)*Y+94.5)/C-Y-3.0)/B+1.0)*XX;
Y := A*Y*Y;
D := Y;
Y := 0.05*Y*Y+Y;
if ( Y > 0.002 ) 
 then Y := Exp(D)-1.0;
goto _4;
_6:
IERR := 66;
_7:
Result := SYS059;
UTSF14(IERR,56);
goto _9;
_8:
Result := X;
_9:
exit;
end;

end.
